	cpu LMM
	.module sensor.c
	.area lit(rom, con, rel)
_FactoryDefault_Param_8::
	.byte 0,0
	.dbfile ./sensor.c
	.dbsym e FactoryDefault_Param_8 _FactoryDefault_Param_8 A[2:2]c
_FactoryDefault_Param_16::
	.word 500
	.word 500
	.word 50000
	.dbsym e FactoryDefault_Param_16 _FactoryDefault_Param_16 A[6:3]i
_FactoryDefault_Param_32::
	.word 0,0
	.dbsym e FactoryDefault_Param_32 _FactoryDefault_Param_32 A[4:1]l
_FactoryDefault_Param_168::
	.byte 52,45,50,48,'m,'A,32,'i,'s,'o,'l,'a,'t,'e,'d,0
	.byte 0,0,0,0,0
	.byte 'F,'r,'a,'m,'e,32,'N,'u,'m,'b,'e,'r,0
	.byte 0,0,0,0,0,0,0,0
	.byte 52,45,50,48,'m,'A,0
	.word 0,0,0,0,0
	.byte 0,0,0,0
	.dbsym e FactoryDefault_Param_168 _FactoryDefault_Param_168 A[63:3:21]c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_NewSample::
	.byte 0
	.dbsym e NewSample _NewSample c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
	.area text(rom, con, rel)
	.dbfile ./sensor.c
	.dbfunc e Sensor_Start _Sensor_Start fV
_Sensor_Start::
	.dbline -1
	.dbline 91
; //*****************************************************************************
; //*****************************************************************************
; //  FILENAME:   sensor.c
; //  Version: 1.0, 2007/03/08
; //  Generated by Andy Kiser
; //
; //  DESCRIPTION:  sensor specific functions 
; //
; //-----------------------------------------------------------------------------
; // Originally authored by Toradex AG. This work is now available under the terms and conditions
; // of the Creative Commons License 'Attribution CC BY', details of which can be found here:
; // http://creativecommons.org/licenses/by/3.0/
; //*****************************************************************************
; //*****************************************************************************
; //#define __DEBUG__
; #include <m8c.h>        // part specific constants and macros
; #include "sensor.h"
; #include "psocgpioint.h"
; #include "spim.h"
; #include "feature.h"
; #include "parameters.h"
; #include "types_n_macros.h"
; //----------------------------------------
; // Sensor parameters
; // Factory Defaults are defined here (NUM_xxx are defined in "sensor.h")
; //----------------------------------------
; const BYTE FactoryDefault_Param_8   [NUM_PARAM_8] =
; {
; 	0x00,		// report mode
; 	0x00		// LED mode
; };
; 
; const WORD FactoryDefault_Param_16  [NUM_PARAM_16] = 
; {
; 	500,		// report rate [ms]
; 	500,		// sample rate [ms]
; 	50000,		// sample rate [us]	(not used for this sensor)
; };
; 
; const DWORD FactoryDefault_Param_32  [NUM_PARAM_32] =
; {
; 	0x00000000	// currently no 32bit parameters
; };
; 
; const tParam_168 FactoryDefault_Param_168 [NUM_PARAM_168] =
; {
; 	"4-20mA isolated",	// user device name
; 	"Frame Number",		// user name Channel 0
; 	"4-20mA",			// user name Channel 1
; };
; 
; 
; //----------------------------------------
; // this module's global variables
; //----------------------------------------
; tReport Report;
; 
; //----------------------------------------
; // constant lookup-table for ADC->physical value conversion
; //----------------------------------------
; 
; 
; //----------------------------------------
; // type definitions
; //----------------------------------------
; 
; typedef enum 
; {	
; 	eReset,
; 	eIdle,
; 	eMeasuring,
; 	eReadADC
; } tFSM_Measure;
; 
; //----------------------------------------
; // variables
; 
; tFSM_Measure	FSM;
; WORD			Countdown_1ms;
; 
; BOOL			NewSample = FALSE;
; 
; // store original drivemodes during suspend
; BYTE			DM0_2, DM0_1, DM0_0;
; BYTE			DM2_2, DM2_1, DM2_0;
; 
; //-----------------------------------------------------------------------------
; // Initializes the Sensor 
; //-----------------------------------------------------------------------------
; void Sensor_Start ()
; {
	.dbline 92
; 	FSM = eReset;
	mov REG[0xd0],>_FSM
	mov [_FSM],0
	.dbline 97
; 
; 	// SCK idle state = 1, to conserve power
; 	// ATTENTION: during each falling edge of nCS, SCK *must* be *low*, to 
; 	//            activate external SCK mode !!!
; 	SPIM_Start(SPIM_SPIM_MODE_1 | SPIM_SPIM_MSB_FIRST);
	push X
	mov A,2
	xcall _SPIM_Start
	pop X
	.dbline 99
; 	// nCS idle state = 1
; 	GPIO_HIGH(nCS)
	or REG[0x8],64
	.dbline 102
; 	
; 	// turn on power for the sensor
; 	GPIO_LOW(OFF_nON)
	and REG[ 0],-2
	.dbline -2
	.dbline 103
; }
L8:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Suspend _Sensor_Suspend fV
_Sensor_Suspend::
	.dbline -1
	.dbline 108
; //-----------------------------------------------------------------------------
; // Prepare Sensor for Suspend
; //-----------------------------------------------------------------------------
; void Sensor_Suspend()
; {
	.dbline 110
; 	// turn off power for the sensor
; 	GPIO_HIGH(OFF_nON)
	or REG[ 0],1
	.dbline 113
; 
; 	// store original drivemodes during  suspend
; 	DM0_2 = PRT0DM2;
	mov A,REG[0x3]
	mov REG[0xd0],>_DM0_2
	mov [_DM0_2],A
	.dbline 114
; 	DM0_1 = PRT0DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x1]
	mov REG[0xd0],>_DM0_1
	mov [_DM0_1],A
	and F,0xEF ; iopage = 0
	.dbline 115
; 	DM0_0 = PRT0DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[ 0]
	mov REG[0xd0],>_DM0_0
	mov [_DM0_0],A
	and F,0xEF ; iopage = 0
	.dbline 116
; 	DM2_2 = PRT2DM2;
	mov A,REG[0xb]
	mov REG[0xd0],>_DM2_2
	mov [_DM2_2],A
	.dbline 117
; 	DM2_1 = PRT2DM1;
	or F,0x10  ; iopage = 1
	mov A,REG[0x9]
	mov REG[0xd0],>_DM2_1
	mov [_DM2_1],A
	and F,0xEF ; iopage = 0
	.dbline 118
; 	DM2_0 = PRT2DM0;
	or F,0x10  ; iopage = 1
	mov A,REG[0x8]
	mov REG[0xd0],>_DM2_0
	mov [_DM2_0],A
	and F,0xEF ; iopage = 0
	.dbline 123
; 	
; 	// set all I/Os to/from the sensor to High-Z Analog (=110), 
; 	// except the OFF_nON signal. 
; 	// OFF_nON is on Port0, all other signals on Port2
; 	PRT0DM2 |= ~OFF_nON_MASK;
	or REG[0x3],-2
	.dbline 124
; 	PRT0DM1 |= ~OFF_nON_MASK;
	or F,0x10  ; iopage = 1
	or REG[0x1],-2
	and F,0xEF ; iopage = 0
	.dbline 125
; 	PRT0DM0 &=  OFF_nON_MASK;
	or F,0x10  ; iopage = 1
	and REG[ 0],1
	and F,0xEF ; iopage = 0
	.dbline 126
; 	PRT2DM2  = 0xFF;
	mov REG[0xb],-1
	.dbline 127
; 	PRT2DM1  = 0xFF;
	or F,0x10  ; iopage = 1
	mov REG[0x9],-1
	and F,0xEF ; iopage = 0
	.dbline 128
; 	PRT2DM0  = 0x00;
	or F,0x10  ; iopage = 1
	mov REG[0x8],0
	and F,0xEF ; iopage = 0
	.dbline -2
	.dbline 130
; 
; }
L9:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Resume _Sensor_Resume fV
;       ReadMode -> X+0
_Sensor_Resume::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 135
; //-----------------------------------------------------------------------------
; // Resume Sensor from Suspend mode
; //-----------------------------------------------------------------------------
; void Sensor_Resume()
; {
	.dbline 139
; 	BYTE ReadMode;
; 	
; 	// restore drivemodes for GPIOs to/from the sensor
; 	PRT2DM2 = DM2_2;
	mov REG[0xd0],>_DM2_2
	mov A,[_DM2_2]
	mov REG[0xb],A
	.dbline 140
; 	PRT2DM1 = DM2_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_1
	mov A,[_DM2_1]
	mov REG[0x9],A
	and F,0xEF ; iopage = 0
	.dbline 141
; 	PRT2DM0 = DM2_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM2_0
	mov A,[_DM2_0]
	mov REG[0x8],A
	and F,0xEF ; iopage = 0
	.dbline 143
; 
; 	PRT0DM2 = DM0_2;
	mov REG[0xd0],>_DM0_2
	mov A,[_DM0_2]
	mov REG[0x3],A
	.dbline 144
; 	PRT0DM1 = DM0_1;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_1
	mov A,[_DM0_1]
	mov REG[0x1],A
	and F,0xEF ; iopage = 0
	.dbline 145
; 	PRT0DM0 = DM0_0;
	or F,0x10  ; iopage = 1
	mov REG[0xd0],>_DM0_0
	mov A,[_DM0_0]
	mov REG[ 0],A
	and F,0xEF ; iopage = 0
	.dbline 148
; 
; 	// start up sensor again
; 	Sensor_Start();
	xcall _Sensor_Start
	.dbline -2
	.dbline 149
; }
L10:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l ReadMode 0 c
	.dbend
	.dbfunc e Sensor_ReadADC _Sensor_ReadADC fV
;             Rx -> X+1
;              i -> X+0
;         Status -> X-7
;     CurrentRaw -> X-5
_Sensor_ReadADC::
	.dbline -1
	push X
	mov X,SP
	add SP,5
	.dbline 161
; 
; //-----------------------------------------------------------------------------
; // Read Raw ADC value from the sensor
; // The function assumes the following (idle) conditions on entry:
; // 		CSn == 0
; //		SCK == 0
; //		MISO== 0 (indicating that conversion has finished)
; // 		SPI-Mode == 0
; // Side Effect
; //-----------------------------------------------------------------------------
; void Sensor_ReadADC (WORD *CurrentRaw, BYTE *Status)
; {
	.dbline 170
; 	signed char i;
; 	union
; 	{
; 		BYTE b[4];
; 		unsigned long ul;
; 	} Rx;
; 	
; 	// -- dummy read to clear RX_BUFFER_FULL flag
; 	SPIM_bReadRxData(); 
	push X
	xcall _SPIM_bReadRxData
	mov REG[0xd0],>__r0
	pop X
	.dbline 173
; 	
; 	// -- receive 3+16+5 bits from the Sensor
; 	for (i=1; i<=3; i++)
	mov [X+0],1
	xjmp L16
L13:
	.dbline 174
; 	{		// read one byte
	.dbline 175
; 		SPIM_SendTxData( 0x00);
	push X
	mov A,0
	xcall _SPIM_SendTxData
	pop X
L17:
	.dbline 176
L18:
	.dbline 176
	push X
	xcall _SPIM_bReadStatus
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	tst [__r0],8
	jz L17
	.dbline 177
	push X
	xcall _SPIM_bReadRxData
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	mov [__r2],3
	mov [__r3],X
	add [__r3],1
	mov A,[X+0]
	mov [__r5],A
	mov [__r4],0
	tst [__r5],-128
	jz X0
	mov [__r4],-1
X0:
	mov REG[0xd0],>__r0
	mov A,[__r5]
	add A,[__r3]
	mov [__r3],A
	mov A,[__r4]
	adc A,[__r2]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	.dbline 178
L14:
	.dbline 173
	inc [X+0]
L16:
	.dbline 173
	mov A,3
	cmp A,[X+0]
	rrc A
	xor A,[X+0]
	xor A,3
	rlc A
	jnc L13
X1:
	.dbline 179
; 		while( !( SPIM_bReadStatus() & SPIM_SPIM_RX_BUFFER_FULL ) );   	
; 		Rx.b[i] = SPIM_bReadRxData();
; 	}
; 	Rx.b[0] = 0;
	mov [X+1],0
	.dbline 182
; 
; 	// -- prepare return values
; 	Rx.ul <<= 3;
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r0],A
	mov A,[X+2]
	mov [__r1],A
	mov A,[X+3]
	mov [__r2],A
	mov A,[X+4]
	mov [__r3],A
	mov A,3
X2:
	mov REG[0xd0],>__r0
	asl [__r3]
	rlc [__r2]
	rlc [__r1]
	rlc [__r0]
	dec A
	jnz X2
	mov A,[__r0]
	mov [X+1],A
	mov A,[__r1]
	mov [X+2],A
	mov A,[__r2]
	mov [X+3],A
	mov A,[__r3]
	mov [X+4],A
	.dbline 184
; 		// 3 Bit Status
; 	*Status     = Rx.b[0];
	mov A,[X-6]
	mov [__r1],A
	mov A,[X-7]
	mov REG[0xd5],A
	mov A,[X+1]
	mvi [__r1],A
	.dbline 186
; 		// 16 bit ADC value
; 	*CurrentRaw = 256*Rx.b[1] + Rx.b[2];
	mov A,[X+3]
	mov [__r1],A
	mov A,[X+2]
	mov [__r0],A
	mov A,[X-4]
	mov [__r3],A
	mov A,[X-5]
	mov REG[0xd5],A
	mov A,[__r0]
	mvi [__r3],A
	mov A,[__r1]
	mvi [__r3],A
	.dbline -2
	.dbline 187
; }
L11:
	add SP,-5
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l Rx 1 X
	.dbsym l i 0 C
	.dbsym l Status -7 pc
	.dbsym l CurrentRaw -5 pi
	.dbend
	.dbfunc e Sensor_Specific_Feature _Sensor_Specific_Feature fc
_Sensor_Specific_Feature::
	.dbline -1
	.dbline 200
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // cannot be handled with the standard functionality in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //
; //	return Value: number of Parameter bytes (1-31) that are 
; //				  returned in the IN report
; //-----------------------------------------------------------------------------
; BYTE Sensor_Specific_Feature(void)
; {
	.dbline 202
; 	// currently no special feature reports are handled
; 	return 0;
	mov REG[0xd0],>__r0
	mov A,0
	.dbline -2
L22:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e Sensor_Specific_Parameter _Sensor_Specific_Parameter fV
; NumberOfReturnedBytes -> X-5
_Sensor_Specific_Parameter::
	.dbline -1
	push X
	mov X,SP
	.dbline 213
; }
; 
; //-----------------------------------------------------------------------------
; // Function that will be called when a FEATURE REPORT is received that 
; // sets / gets a 8/16/32/168bit parameter in feature.c
; // The feature report data is available in the "FEATURE_RPT" variable
; //
; // --> see feature.c for an example how to parse FEATURE_RPT
; //-----------------------------------------------------------------------------
; void Sensor_Specific_Parameter(BYTE *NumberOfReturnedBytes)
; {
	.dbline -2
	.dbline 215
; 	// currently there are no specific parameters
; }
L23:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l NumberOfReturnedBytes -5 pc
	.dbend
	.dbfunc e Sensor_FSM_Measure _Sensor_FSM_Measure fV
;            ADC -> X+6
;         Status -> X+5
;        Current -> X+1
;              i -> X+0
_Sensor_FSM_Measure::
	.dbline -1
	push X
	mov X,SP
	add SP,10
	.dbline 227
; 
; //-----------------------------------------------------------------------------
; // void Sensor_FSM_Measure(void)
; //
; //	finite state machine to control the measurement process for 
; //  the Sensor
; //
; //  IMPORTANT: 	call this routine once every millisecond. Otherwise the timing
; //				parameters cannot be met.
; //-----------------------------------------------------------------------------
; void Sensor_FSM_Measure() 
; {
	.dbline 240
; 	WORD ADC;
; 	BYTE Status;
; 	char i;
; 	
; 	union
; 	{
; 		BYTE			b[4];
; 		WORD			w[2];
; 		unsigned long 	ul;
; 	} Current;
; 
; 	// decrement millisecond counter
; 	if (Countdown_1ms != 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz X4
	cmp [_Countdown_1ms+1],0
	jz L26
X4:
	.dbline 241
; 		Countdown_1ms--;
	mov REG[0xd0],>_Countdown_1ms
	dec [_Countdown_1ms+1]
	sbb [_Countdown_1ms],0
L26:
	.dbline 244
; 
; 	// process actual state machine
; 	switch (FSM)
	mov REG[0xd0],>_FSM
	mov A,[_FSM]
	mov [X+9],A
	mov [X+8],0
	cmp [X+8],0
	jnz X5
	cmp [X+9],0
	jz L31
X5:
	cmp [X+8],0
	jnz X6
	cmp [X+9],2
	jz L32
X6:
	cmp [X+8],0
	jnz X7
	cmp [X+9],3
	jz L46
X7:
	xjmp L28
X3:
	.dbline 245
; 	{
L31:
	.dbline 248
; 		case eReset:
; 			// ADC automatically starts conversion on Power-on Reset (POR)
; 			FSM = eMeasuring;
	mov REG[0xd0],>_FSM
	mov [_FSM],2
	.dbline 249
; 			break;
	xjmp L29
L32:
	.dbline 252
; 			
; 		case eMeasuring:
; 			if (Countdown_1ms == 151)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L33
	cmp [_Countdown_1ms+1],-105
	jnz L33
X8:
	.dbline 253
; 			{
	.dbline 255
; 				// Activate SPI and bring SCK signal to low
; 				SPIM_Start(SPIM_SPIM_MODE_0 | SPIM_SPIM_MSB_FIRST);
	push X
	mov A,0
	xcall _SPIM_Start
	pop X
	.dbline 258
; 				
; 				// activate nCS to be able to detect EOC flag
; 				GPIO_LOW(nCS)  
	and REG[0x8],-65
	.dbline 259
	mov [X+0],0
	xjmp L38
L35:
	.dbline 259
L36:
	.dbline 259
	inc [X+0]
L38:
	.dbline 259
; 				for(i=0; i<10;i++);  // short delay to allow signal to settle
	cmp [X+0],10
	jc L35
X9:
	.dbline 260
; 				if ( (MISO_Data_ADDR & MISO_MASK) == 0 )
	tst REG[0x8],16
	jnz L39
	.dbline 261
; 				{	
	.dbline 264
; 					// Countdown_1ms == 151, enough time to do one more conversion, before result is requested
; 					// => generate at least one clock cycle
; 					SPIM_bReadRxData(); 	// dummy read to clear RX_BUFFER_FULL flag
	push X
	xcall _SPIM_bReadRxData
	mov REG[0xd0],>__r0
	pop X
	.dbline 265
; 					SPIM_SendTxData( 0x00);
	push X
	mov A,0
	xcall _SPIM_SendTxData
	pop X
L41:
	.dbline 266
L42:
	.dbline 266
; 					while( !( SPIM_bReadStatus() & SPIM_SPIM_RX_BUFFER_FULL ) );   	
	push X
	xcall _SPIM_bReadStatus
	mov REG[0xd0],>__r0
	pop X
	mov [__r0],A
	tst [__r0],8
	jz L41
	.dbline 267
; 				}
L39:
	.dbline 269
; 				// deactivate nCS to start a new conversion
; 				GPIO_HIGH(nCS)
	or REG[0x8],64
	.dbline 270
; 				SPIM_Start(SPIM_SPIM_MODE_1 | SPIM_SPIM_MSB_FIRST);
	push X
	mov A,2
	xcall _SPIM_Start
	pop X
	.dbline 271
; 			}
L33:
	.dbline 272
; 			if (Countdown_1ms <= 151)
	mov REG[0xd0],>_Countdown_1ms
	mov A,-105
	sub A,[_Countdown_1ms+1]
	mov A,0
	sbb A,[_Countdown_1ms]
	jc L29
X10:
	.dbline 273
; 				FSM = eReadADC;
	mov REG[0xd0],>_FSM
	mov [_FSM],3
	.dbline 274
; 			break;
	xjmp L29
L46:
	.dbline 277
; 
; 		case eReadADC:
; 			if (Countdown_1ms == 0)
	mov REG[0xd0],>_Countdown_1ms
	cmp [_Countdown_1ms],0
	jnz L29
	cmp [_Countdown_1ms+1],0
	jnz L29
X11:
	.dbline 278
; 			{
	.dbline 280
; 				// Activate SPI and bring SCK signal to low
; 				SPIM_Start(SPIM_SPIM_MODE_0 | SPIM_SPIM_MSB_FIRST);
	push X
	mov A,0
	xcall _SPIM_Start
	pop X
	.dbline 282
; 			
; 				GPIO_LOW(nCS)
	and REG[0x8],-65
	.dbline 283
	mov [X+0],0
	xjmp L52
L49:
	.dbline 283
L50:
	.dbline 283
	inc [X+0]
L52:
	.dbline 283
; 				for(i=0; i<10;i++);  // short delay to allow signal to settle
	cmp [X+0],10
	jc L49
X12:
	.dbline 284
; 				if ( (MISO_Data_ADDR & MISO_MASK) == 0 )
	tst REG[0x8],16
	jnz L53
	.dbline 285
; 				{
	.dbline 287
; 					// reset samplerate counter
; 					Get_Param_16(PAR16_SAMPLERATE_MS, VOLATILE, &Countdown_1ms);
	mov A,>_Countdown_1ms
	push A
	mov A,<_Countdown_1ms
	push A
	mov A,0
	push A
	mov A,1
	push A
	xcall _Get_Param_16
	.dbline 288
; 					Countdown_1ms -=3; // offset for processing that takes longer than 1ms
	mov REG[0xd0],>_Countdown_1ms
	sub [_Countdown_1ms+1],3
	sbb [_Countdown_1ms],0
	.dbline 289
; 					FSM = eMeasuring;
	mov REG[0xd0],>_FSM
	mov [_FSM],2
	.dbline 292
; 
; 					// reading the ADC automatically starts a new conversion.
; 					Sensor_ReadADC (&Current.w[0], &Status);
	mov REG[0xd0],>__r0
	mov [__r1],X
	add [__r1],5
	mov A,3
	push A
	mov A,[__r1]
	push A
	mov [__r1],X
	add [__r1],1
	mov A,3
	push A
	mov A,[__r1]
	push A
	xcall _Sensor_ReadADC
	add SP,-8
	.dbline 293
; 					Current.w[1] = 0;
	mov [X+4],0
	mov [X+3],0
	.dbline 296
; 
; 					// Calculate Current  0...65536 -> 0...20.48mA -> 0...20480
; 					Current.ul >>= 1;
	and F,-5
	rrc [X+1]
	rrc [X+2]
	rrc [X+3]
	rrc [X+4]
	.dbline 297
; 					Current.ul += Current.ul >>2;
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r0],A
	mov A,[X+2]
	mov [__r1],A
	mov A,[X+3]
	mov [__r2],A
	mov A,[X+4]
	mov [__r3],A
	mov A,2
X13:
	and F,-5
	mov REG[0xd0],>__r0
	rrc [__r0]
	rrc [__r1]
	rrc [__r2]
	rrc [__r3]
	dec A
	jnz X13
	mov A,[__r3]
	add [X+4],A
	mov A,[__r2]
	adc [X+3],A
	mov A,[__r1]
	adc [X+2],A
	mov A,[__r0]
	adc [X+1],A
	.dbline 300
; 					// fill data into IN report
; 
; 					Report.Ch1_LSB = Current.b[1];
	mov A,[X+2]
	mov REG[0xd0],>_Report
	mov [_Report+2],A
	.dbline 301
; 					Report.Ch1_MSB =  Current.b[0];
	mov A,[X+1]
	mov [_Report+3],A
	.dbline 302
; 					NewSample = TRUE;
	mov REG[0xd0],>_NewSample
	mov [_NewSample],1
	.dbline 303
; 				}
L53:
	.dbline 304
; 				GPIO_HIGH(nCS)
	or REG[0x8],64
	.dbline 305
; 				SPIM_Start(SPIM_SPIM_MODE_1 | SPIM_SPIM_MSB_FIRST); // only to bring SCK to high
	push X
	mov A,2
	xcall _SPIM_Start
	pop X
	.dbline 306
; 			}
	.dbline 307
; 			break;			
L28:
L29:
	.dbline -2
	.dbline 309
; 	}
; }
L24:
	add SP,-10
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l ADC 6 i
	.dbsym l Status 5 c
	.dbsym l Current 1 X
	.dbsym l i 0 c
	.dbend
	.dbfunc e Sensor_Debug _Sensor_Debug fV
_Sensor_Debug::
	.dbline -1
	.dbline 313
; 
; //-----------------------------------------------------------------------------
; void Sensor_Debug(void)
; {
	.dbline -2
	.dbline 315
; /* currently no debug function */
; }
L59:
	.dbline 0 ; func end
	ret
	.dbend
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_0::
	.byte 0
	.dbsym e DM2_0 _DM2_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_1::
	.byte 0
	.dbsym e DM2_1 _DM2_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM2_2::
	.byte 0
	.dbsym e DM2_2 _DM2_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_0::
	.byte 0
	.dbsym e DM0_0 _DM0_0 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_1::
	.byte 0
	.dbsym e DM0_1 _DM0_1 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_DM0_2::
	.byte 0
	.dbsym e DM0_2 _DM0_2 c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Countdown_1ms::
	.byte 0,0
	.dbsym e Countdown_1ms _Countdown_1ms i
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_FSM::
	.byte 0
	.dbsym e FSM _FSM c
	.area data(ram, con, rel)
	.dbfile ./sensor.c
_Report::
	.byte 0,0,0,0
	.dbsym e Report _Report X
